<template xmlns:input="http://www.w3.org/1999/html">
  <div id="payment-block" class="row">
    <ajax-loader v-if="loading"></ajax-loader>

    <div class="column" v-show="wayPay" style="margin-bottom: -15px;">
      <div class="white-block" style="border-bottom-left-radius: 0; border-bottom-right-radius: 0;">
        <div class="section__header section__header-with-back">
          <div class="section__header-back" v-on:click="$emit('back')">
            <SVGIcon xlink="next-arrow-20" viewBox="0 0 20 20" :rotate="180"/>
          </div>
          <h3 class="section__header-title">Выберите способ оплаты</h3>
          <slot name="close" v-if="!history"></slot>
        </div>
        <div class="padding payment-method-choose">
          <div class="flex-column">
            <div v-for="(chunk, chunkId) in chunkedMethods" class="p-m-block"
                 :class="{'adaptive-hidden': chunkId > 0 && !showMore}">
              <div v-for="(method, numberInChunk) in chunk"
                   @click="activeItem = method.shortname; changeAndMove(method.component)"
                   :class="{
                            active: activeItem === method.shortname,
                            first: numberInChunk % 2 === 0,
                         }"
                   class="item">
                <img :src="`/lk/static/img/pay/${method.shortname}.png`" alt="">{{ method.description }}
              </div>
            </div>
          </div>

          <div class="adaptive-button">
            <button @click="showMore = !showMore">{{ showMore ? "Скрыть" : "Показать все" }}</button>
          </div>

          <slot name="installment"></slot>

        </div>
        <!--<div ref="dynamicComponent">-->
        <!--<component :sum-to-pay="sumToPay"-->
        <!--:is="paymentMethodComponent"-->
        <!--@success="success">-->
        <!--</component>-->
        <!--</div>-->
        <warning-message></warning-message>
      </div>
    </div>
    <div ref="dynamicComponent" v-show="!wayPay">
      <component :sum-to-pay="sumToPay"
                 :is="paymentMethodComponent"
                 @success="success"
                 @return-to-loan="back"
                 @hideForm="hideForm">
      </component>
    </div>
    <div class="white-block" v-show="wayPay && $route.meta.section !== 'pos' ">
      <div class="padding row" style="margin-top: -10px;">
        <a class="legal-protection__link link blue" @click="$emit('back')">Перейти к займу</a></div>
    </div>
  </div>
</template>

<script>
  import Sberbank from '@/components/Pay/PaymentMethods/Sberbank'
  import Invoice from '@/components/Pay/PaymentMethods/Invoice'
  import Qiwi from '@/components/Pay/PaymentMethods/Qiwi'
  import Mkb from '@/components/Pay/PaymentMethods/Mkb'
  import GoldCrown from '@/components/Pay/PaymentMethods/GoldCrown'
  import ElexNet from '@/components/Pay/PaymentMethods/ElexNet'
  import RuRu from '@/components/Pay/PaymentMethods/RuRu'
  import BankTransfer from '@/components/Pay/PaymentMethods/BankTransfer'
  import RussianPost from '@/components/Pay/PaymentMethods/RussianPost'
  import Phone from '@/components/Pay/PaymentMethods/Phone'
  import YandexWallet from '@/components/Pay/PaymentMethods/YandexWallet'
  import Card from '@/components/Pay/PaymentMethods/Card'
  import chunk from 'lodash/chunk'
  import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage'
  import SVGIcon from "../SVGIcon/index";
  
  export default {
    name: 'payment',
    components: {
      SVGIcon,
      Sberbank,
      Invoice,
      Qiwi,
      Mkb,
      YandexWallet,
      GoldCrown,
      ElexNet,
      BankTransfer,
      RuRu,
      RussianPost,
      Phone,
      Card,
      WarningMessage
    },
    // props: ['sum-to-pay'],
    props: {
      installment: {
        type: Boolean,
        default: false
      },
      history:{
        type: Boolean,
        default: false,
      }
    },
    data () {
      return {
        wayPay: true,
        loading: false,
        paymentMethodComponent: '',
        activeItem: '',
        showMore: false,
        staticPaymentMethodsDirectory: [
          {id: 0, shortname: 'card', description: 'Банковская карта', component: 'Card'},
          {id: 1, shortname: 'sber', description: 'Сбербанк онлайн', component: 'Sberbank'},
          {id: 3, shortname: 'yandex', description: 'Кошелек Яндекс.Деньги', component: 'YandexWallet'},
          {id: 4, shortname: 'phone', description: 'Мобильный телефон', component: 'Phone'}
        ],
        paymentMethodsDirectory: [
          {id: 5, shortname: 'russian_post', description: 'Почта России', component: 'RussianPost'},
          {id: 6, shortname: 'mkb', description: 'Московский кредитный банк', component: 'Mkb'},
          {id: 7, shortname: 'bank_transfer', description: 'Банковский перевод', component: 'BankTransfer'},
          // {id: 8, shortname: 'gold-crown', description: 'Золотая корона', component: 'GoldCrown'},
          {id: 9, shortname: 'qiwi', description: 'QIWI', component: 'Qiwi'},
          {id: 10, shortname: 'elecsnet', description: 'Элекснет', component: 'ElexNet'},
          // {id: 11, shortname: 'ruru', description: 'RuRu', component: 'RuRu'}
        ],
        office: []
      }
    },
    computed: {
      paymentMethods () {
        return [
          ...this.staticPaymentMethodsDirectory,
          ...this.paymentMethodsDirectory.filter(method => this.$store.getters.getPaymentMethods(method.shortname))
        ]
      },
      chunkedMethods () {
        return chunk(this.paymentMethods, 4)
      },
      sumToPay () {
        if (this.$store.getters.getPaymentAmount) {
          return this.$store.getters.getPaymentAmount
        }
        return this.$payment.totalDebt;// && this.$store.commit('CHECK_ACTIVE_PROLONGATION', {status: false, type: 1, id: null})
      }
    },

      watch: {
          wayPay () {
              this.$nextTick(() => {
                  this.$helpers.scroll(this.$refs.payMethods);
              })
          },
          paymentMethodComponent () {
              console.log('Payment::watch', 'paymentMethodComponent', this.paymentMethodComponent);
              this.setAmount();
              this.$nextTick(() => {
                  this.$helpers.scroll(this.$refs.payMethods);
              })
          },
          '$pay.paymentType' (type) {
              /**
               * смена суммы - значит сменен тип платежа (пошагение займа, оплата пролонгации/рассрочка).
               */

              this.$nextTick(() => {
                  this.$helpers.scroll(this.$el, 'payment animation start').then(() => {
                      console.log('payment animation end');
                  })
              });

          },

          // paymentMethodComponent () {
          //
          // }
      },

    mounted () {
      this.$store.dispatch('getPaymentParams');
      this.loading = false;
      /**
       * если мы платим депозит пролонгации, то необходимо приплюсовать стоимость допника пос
       */
      this.setAmount();
      this.$backend.api.services.all()
        .then(({data}) => {
          data = data.data.filter((key) => {
            return [2, 3, 6, 7].includes(key.location_int)
          });
          this.$store.commit('setServiceList', data)
        })
        .catch(err => console.log('err', err))
    },
    destroyed () {
      this.$store.commit('setServiceGuid', {data: []});
    },
    methods: {
      success () {
        console.log('Payment::success');
        this.$emit('success');
        this.paymentMethodComponent = '';
      },
        back() {
          console.log('Payment::back');
          this.$emit('back');
        },
        hideForm () {
          console.log('Payment::hideForm');
          this.wayPay = true
        },
      setAmount () {
        if (this.$pay.paymentType === 'prolongation_deposit') {
          let amount = this.$pdl.supplementary.prolongation.depositAmount;
          if (this.$posServices) {
            amount += this.$posServices.sumTotal;
          }

          this.$store.commit('SET_PAYMENT', {
            type: 'prolongation_deposit',
            amount
          })
        }
      },

      makeThisActive ({target}, newprop) {
        Object.values(this.$refs).forEach(element => element === target ? element.classList.add('active') : element.classList.remove('active')) // Устанавливаем класс через $refs
      },
      changeAndMove (component) {
          console.log('Payment::changeAndMove', component);
        this.paymentMethodComponent = component;
        this.wayPay = false
        this.$helpers.scroll(this.$refs.dynamicComponent)
      }
    }
  }
</script>

<style scoped lang="sass">
  @import "./../../../static/css/mixins/main";
  .item {
    color: #000 !important;
  }
    
    .flex-column {
      @include flex(flex, column, wrap);
    }
</style>
